From 5f56a6b5bb64abc6e8300bc1ebfd87e7cbc7ff21 Mon Sep 17 00:00:00 2001
From: Marko Lindqvist <cazfi74@gmail.com>
Date: Fri, 29 Mar 2024 11:55:03 +0200
Subject: [PATCH 41/41] Correct "fullfilled" to "fulfilled"

See RM #371

Signed-off-by: Marko Lindqvist <cazfi74@gmail.com>
---
 common/research.c               | 2 +-
 data/alien/game.ruleset         | 2 +-
 data/civ1/game.ruleset          | 2 +-
 data/civ2/game.ruleset          | 2 +-
 data/classic/game.ruleset       | 2 +-
 data/goldkeep/game.ruleset      | 2 +-
 data/granularity/game.ruleset   | 2 +-
 data/multiplayer/game.ruleset   | 2 +-
 data/ruledit/comments-3.3.txt   | 2 +-
 data/sandbox/game.ruleset       | 2 +-
 data/stub/game.ruleset          | 2 +-
 data/webperimental/game.ruleset | 2 +-
 doc/README.effects              | 2 +-
 server/diplhand.c               | 2 +-
 14 files changed, 14 insertions(+), 14 deletions(-)

diff --git a/common/research.c b/common/research.c
index 01f60fad40..d6f4ee3fbf 100644
--- a/common/research.c
+++ b/common/research.c
@@ -493,7 +493,7 @@ static bool research_get_root_reqs_known(const struct research *presearch,
 
 /************************************************************************//**
   Mark as TECH_PREREQS_KNOWN each tech which is available, not known and
-  which has all requirements fullfiled.
+  which has all requirements fulfilled.
 
   Recalculate presearch->num_known_tech_with_flag
   Should always be called after research_invention_set().
diff --git a/data/alien/game.ruleset b/data/alien/game.ruleset
index 56198079b0..3d05ba9f31 100644
--- a/data/alien/game.ruleset
+++ b/data/alien/game.ruleset
@@ -558,7 +558,7 @@ goods_selection = "Arrival"
 ;                           goods any more. Bidirectional routes gets cancelled if either
 ;                           one of the involved cities cannot provide goods.
 ;   - "Self-Provided"     = Good requirement (in requirement lists of other rules)
-;                           is fullfilled also for the city exporting, or capable of exporting,
+;                           is fulfilled also for the city exporting, or capable of exporting,
 ;                           the good. Otherwise it would be true only for cities importing the
 ;                           good from elsewhere.
 ; helptext                = Optional help text string; should escape all raw
diff --git a/data/civ1/game.ruleset b/data/civ1/game.ruleset
index eefb622eaa..163a7baac1 100644
--- a/data/civ1/game.ruleset
+++ b/data/civ1/game.ruleset
@@ -590,7 +590,7 @@ goods_selection = "Arrival"
 ;                           goods any more. Bidirectional routes gets cancelled if either
 ;                           one of the involved cities cannot provide goods.
 ;   - "Self-Provided"     = Good requirement (in requirement lists of other rules)
-;                           is fullfilled also for the city exporting, or capable of exporting,
+;                           is fulfilled also for the city exporting, or capable of exporting,
 ;                           the good. Otherwise it would be true only for cities importing the
 ;                           good from elsewhere.
 ; helptext                = Optional help text string; should escape all raw
diff --git a/data/civ2/game.ruleset b/data/civ2/game.ruleset
index e08d49cca1..284c8081aa 100644
--- a/data/civ2/game.ruleset
+++ b/data/civ2/game.ruleset
@@ -521,7 +521,7 @@ goods_selection = "Arrival"
 ;                           goods any more. Bidirectional routes gets cancelled if either
 ;                           one of the involved cities cannot provide goods.
 ;   - "Self-Provided"     = Good requirement (in requirement lists of other rules)
-;                           is fullfilled also for the city exporting, or capable of exporting,
+;                           is fulfilled also for the city exporting, or capable of exporting,
 ;                           the good. Otherwise it would be true only for cities importing the
 ;                           good from elsewhere.
 ; helptext                = Optional help text string; should escape all raw
diff --git a/data/classic/game.ruleset b/data/classic/game.ruleset
index 61e8d770e0..d020f21db9 100644
--- a/data/classic/game.ruleset
+++ b/data/classic/game.ruleset
@@ -573,7 +573,7 @@ goods_selection = "Arrival"
 ;                           goods any more. Bidirectional routes gets cancelled if either
 ;                           one of the involved cities cannot provide goods.
 ;   - "Self-Provided"     = Good requirement (in requirement lists of other rules)
-;                           is fullfilled also for the city exporting, or capable of exporting,
+;                           is fulfilled also for the city exporting, or capable of exporting,
 ;                           the good. Otherwise it would be true only for cities importing the
 ;                           good from elsewhere.
 ; helptext                = Optional help text string; should escape all raw
diff --git a/data/goldkeep/game.ruleset b/data/goldkeep/game.ruleset
index 66eb66dea2..077badf5d7 100644
--- a/data/goldkeep/game.ruleset
+++ b/data/goldkeep/game.ruleset
@@ -591,7 +591,7 @@ goods_selection = "Leaving"
 ;                           goods any more. Bidirectional routes gets cancelled if either
 ;                           one of the involved cities cannot provide goods.
 ;   - "Self-Provided"     = Good requirement (in requirement lists of other rules)
-;                           is fullfilled also for the city exporting, or capable of exporting,
+;                           is fulfilled also for the city exporting, or capable of exporting,
 ;                           the good. Otherwise it would be true only for cities importing the
 ;                           good from elsewhere.
 ; helptext                = Optional help text string; should escape all raw
diff --git a/data/granularity/game.ruleset b/data/granularity/game.ruleset
index 70eca325a2..984d4fd870 100644
--- a/data/granularity/game.ruleset
+++ b/data/granularity/game.ruleset
@@ -542,7 +542,7 @@ goods_selection = "Leaving"
 ;                           goods any more. Bidirectional routes gets cancelled if either
 ;                           one of the involved cities cannot provide goods.
 ;   - "Self-Provided"     = Good requirement (in requirement lists of other rules)
-;                           is fullfilled also for the city exporting, or capable of exporting,
+;                           is fulfilled also for the city exporting, or capable of exporting,
 ;                           the good. Otherwise it would be true only for cities importing the
 ;                           good from elsewhere.
 ; helptext                = Optional help text string; should escape all raw
diff --git a/data/multiplayer/game.ruleset b/data/multiplayer/game.ruleset
index 5a5982116d..ff7d296bf3 100644
--- a/data/multiplayer/game.ruleset
+++ b/data/multiplayer/game.ruleset
@@ -540,7 +540,7 @@ goods_selection = "Arrival"
 ;                           goods any more. Bidirectional routes gets cancelled if either
 ;                           one of the involved cities cannot provide goods.
 ;   - "Self-Provided"     = Good requirement (in requirement lists of other rules)
-;                           is fullfilled also for the city exporting, or capable of exporting,
+;                           is fulfilled also for the city exporting, or capable of exporting,
 ;                           the good. Otherwise it would be true only for cities importing the
 ;                           good from elsewhere.
 ; helptext                = Optional help text string; should escape all raw
diff --git a/data/ruledit/comments-3.3.txt b/data/ruledit/comments-3.3.txt
index 562fd2cd89..5cbe7034be 100644
--- a/data/ruledit/comments-3.3.txt
+++ b/data/ruledit/comments-3.3.txt
@@ -1138,7 +1138,7 @@ goods = "\
 ;                           goods any more. Bidirectional routes gets cancelled if either\n\
 ;                           one of the involved cities cannot provide goods.\n\
 ;   - \"Self-Provided\"     = Good requirement (in requirement lists of other rules)\n\
-;                           is fullfilled also for the city exporting, or capable of exporting,\n\
+;                           is fulfilled also for the city exporting, or capable of exporting,\n\
 ;                           the good. Otherwise it would be true only for cities importing the\n\
 ;                           good from elsewhere.\n\
 ; helptext                = Optional help text string; should escape all raw\n\
diff --git a/data/sandbox/game.ruleset b/data/sandbox/game.ruleset
index 81997f1660..14d384b279 100644
--- a/data/sandbox/game.ruleset
+++ b/data/sandbox/game.ruleset
@@ -658,7 +658,7 @@ goods_selection = "Leaving"
 ;                           goods any more. Bidirectional routes gets cancelled if either
 ;                           one of the involved cities cannot provide goods.
 ;   - "Self-Provided"     = Good requirement (in requirement lists of other rules)
-;                           is fullfilled also for the city exporting, or capable of exporting,
+;                           is fulfilled also for the city exporting, or capable of exporting,
 ;                           the good. Otherwise it would be true only for cities importing the
 ;                           good from elsewhere.
 ; helptext                = Optional help text string; should escape all raw
diff --git a/data/stub/game.ruleset b/data/stub/game.ruleset
index e1b6d3291c..c9b644d7ca 100644
--- a/data/stub/game.ruleset
+++ b/data/stub/game.ruleset
@@ -533,7 +533,7 @@ goods_selection = "Leaving"
 ;                           goods any more. Bidirectional routes gets cancelled if either
 ;                           one of the involved cities cannot provide goods.
 ;   - "Self-Provided"     = Good requirement (in requirement lists of other rules)
-;                           is fullfilled also for the city exporting, or capable of exporting,
+;                           is fulfilled also for the city exporting, or capable of exporting,
 ;                           the good. Otherwise it would be true only for cities importing the
 ;                           good from elsewhere.
 ; helptext                = Optional help text string; should escape all raw
diff --git a/data/webperimental/game.ruleset b/data/webperimental/game.ruleset
index ec22dd0f69..1b89da094e 100644
--- a/data/webperimental/game.ruleset
+++ b/data/webperimental/game.ruleset
@@ -577,7 +577,7 @@ goods_selection = "Leaving"
 ;                           goods any more. Bidirectional routes gets cancelled if either
 ;                           one of the involved cities cannot provide goods.
 ;   - "Self-Provided"     = Good requirement (in requirement lists of other rules)
-;                           is fullfilled also for the city exporting, or capable of exporting,
+;                           is fulfilled also for the city exporting, or capable of exporting,
 ;                           the good. Otherwise it would be true only for cities importing the
 ;                           good from elsewhere.
 ; helptext                = Optional help text string; should escape all raw
diff --git a/doc/README.effects b/doc/README.effects
index 5909f48dcf..6497cb6d2a 100644
--- a/doc/README.effects
+++ b/doc/README.effects
@@ -131,7 +131,7 @@ MinLatitude and MaxLatitude are numbers from -1000 (south pole) to 1000
 CityStatus is "OwnedByOriginal", "Transferred", "Starved",
  "Disorder", or "Celebration"
  The difference between "OwnedByOriginal" and "Transferred" is that
- former is fullfilled also for liberated cities.
+ former is fulfilled also for liberated cities.
 DiplRel is a diplomatic relationship.
 MaxUnitsOnTile is about the number of units present on a tile.
 UnitState is "Transported", "Transporting", "OnNativeTile", "OnLivableTile",
diff --git a/server/diplhand.c b/server/diplhand.c
index 6dc356f7c2..988ba6df15 100644
--- a/server/diplhand.c
+++ b/server/diplhand.c
@@ -188,7 +188,7 @@ void handle_diplomacy_accept_treaty_req(struct player *pplayer,
                              &(info->giver_reqs), RPT_POSSIBLE)
             || !are_reqs_active(&other_ctxt, pplayer,
                                 &(info->receiver_reqs), RPT_POSSIBLE)) {
-          log_error("Requirements of a clause between %s and %s not fullfilled",
+          log_error("Requirements of a clause between %s and %s not fulfilled",
                     player_name(pplayer), player_name(pother));
           return;
         }
-- 
2.43.0