From a455dae3c42359cde192637e6dec4bb2489e3f22 Mon Sep 17 00:00:00 2001
From: Marko Lindqvist <cazfi74@gmail.com>
Date: Sun, 31 Mar 2024 09:09:26 +0300
Subject: [PATCH 48/48] Correct .modpack file comment

They were missing word "is"

See RM #337

Signed-off-by: Marko Lindqvist <cazfi74@gmail.com>
---
 data/alien.modpack         | 2 +-
 data/civ1.modpack          | 2 +-
 data/civ2.modpack          | 2 +-
 data/civ2civ3.modpack      | 2 +-
 data/classic.modpack       | 2 +-
 data/default.modpack       | 2 +-
 data/goldkeep.modpack      | 2 +-
 data/granularity.modpack   | 2 +-
 data/multiplayer.modpack   | 2 +-
 data/sandbox.modpack       | 2 +-
 data/stub.modpack          | 2 +-
 data/webperimental.modpack | 2 +-
 12 files changed, 12 insertions(+), 12 deletions(-)

diff --git a/data/alien.modpack b/data/alien.modpack
index 66168ddeb1..f3d49a3581 100644
--- a/data/alien.modpack
+++ b/data/alien.modpack
@@ -13,5 +13,5 @@ ruleset = TRUE
 [ruleset]
 ; For modpacks with the ruleset component, either "rulesetdir" or "serv" needs to be defined.
 ; - "rulesetdir" gives the directory where the ruleset is
-; - "serv" gives a server script to load, and which assumed to also set the rulesetdir
+; - "serv" gives a server script to load, and which is assumed to also set the rulesetdir
 rulesetdir = "alien"
diff --git a/data/civ1.modpack b/data/civ1.modpack
index 45d6a77ddc..af572009a9 100644
--- a/data/civ1.modpack
+++ b/data/civ1.modpack
@@ -13,5 +13,5 @@ ruleset = TRUE
 [ruleset]
 ; For modpacks with the ruleset component, either "rulesetdir" or "serv" needs to be defined.
 ; - "rulesetdir" gives the directory where the ruleset is
-; - "serv" gives a server script to load, and which assumed to also set the rulesetdir
+; - "serv" gives a server script to load, and which is assumed to also set the rulesetdir
 rulesetdir = "civ1"
diff --git a/data/civ2.modpack b/data/civ2.modpack
index c257778316..ae65fadd21 100644
--- a/data/civ2.modpack
+++ b/data/civ2.modpack
@@ -13,5 +13,5 @@ ruleset = TRUE
 [ruleset]
 ; For modpacks with the ruleset component, either "rulesetdir" or "serv" needs to be defined.
 ; - "rulesetdir" gives the directory where the ruleset is
-; - "serv" gives a server script to load, and which assumed to also set the rulesetdir
+; - "serv" gives a server script to load, and which is assumed to also set the rulesetdir
 rulesetdir = "civ2"
diff --git a/data/civ2civ3.modpack b/data/civ2civ3.modpack
index 22cafd0e9b..8b4152fb21 100644
--- a/data/civ2civ3.modpack
+++ b/data/civ2civ3.modpack
@@ -13,5 +13,5 @@ ruleset = TRUE
 [ruleset]
 ; For modpacks with the ruleset component, either "rulesetdir" or "serv" needs to be defined.
 ; - "rulesetdir" gives the directory where the ruleset is
-; - "serv" gives a server script to load, and which assumed to also set the rulesetdir
+; - "serv" gives a server script to load, and which is assumed to also set the rulesetdir
 rulesetdir = "civ2civ3"
diff --git a/data/classic.modpack b/data/classic.modpack
index 186a4a96c9..0b11610c6c 100644
--- a/data/classic.modpack
+++ b/data/classic.modpack
@@ -13,5 +13,5 @@ ruleset = TRUE
 [ruleset]
 ; For modpacks with the ruleset component, either "rulesetdir" or "serv" needs to be defined.
 ; - "rulesetdir" gives the directory where the ruleset is
-; - "serv" gives a server script to load, and which assumed to also set the rulesetdir
+; - "serv" gives a server script to load, and which is assumed to also set the rulesetdir
 rulesetdir = "classic"
diff --git a/data/default.modpack b/data/default.modpack
index b1eecc1c08..f9e952feda 100644
--- a/data/default.modpack
+++ b/data/default.modpack
@@ -13,5 +13,5 @@ ruleset = TRUE
 [ruleset]
 ; For modpacks with the ruleset component, either "rulesetdir" or "serv" needs to be defined.
 ; - "rulesetdir" gives the directory where the ruleset is
-; - "serv" gives a server script to load, and which assumed to also set the rulesetdir
+; - "serv" gives a server script to load, and which is assumed to also set the rulesetdir
 rulesetdir = "civ2civ3"
diff --git a/data/goldkeep.modpack b/data/goldkeep.modpack
index 65755eb2c5..3d4d82a514 100644
--- a/data/goldkeep.modpack
+++ b/data/goldkeep.modpack
@@ -13,5 +13,5 @@ ruleset = TRUE
 [ruleset]
 ; For modpacks with the ruleset component, either "rulesetdir" or "serv" needs to be defined.
 ; - "rulesetdir" gives the directory where the ruleset is
-; - "serv" gives a server script to load, and which assumed to also set the rulesetdir
+; - "serv" gives a server script to load, and which is assumed to also set the rulesetdir
 rulesetdir = "goldkeep"
diff --git a/data/granularity.modpack b/data/granularity.modpack
index 44848dd977..ef49719db9 100644
--- a/data/granularity.modpack
+++ b/data/granularity.modpack
@@ -13,5 +13,5 @@ ruleset = TRUE
 [ruleset]
 ; For modpacks with the ruleset component, either "rulesetdir" or "serv" needs to be defined.
 ; - "rulesetdir" gives the directory where the ruleset is
-; - "serv" gives a server script to load, and which assumed to also set the rulesetdir
+; - "serv" gives a server script to load, and which is assumed to also set the rulesetdir
 serv = "granularity.serv"
diff --git a/data/multiplayer.modpack b/data/multiplayer.modpack
index 57297785b1..2e7fdedc52 100644
--- a/data/multiplayer.modpack
+++ b/data/multiplayer.modpack
@@ -13,5 +13,5 @@ ruleset = TRUE
 [ruleset]
 ; For modpacks with the ruleset component, either "rulesetdir" or "serv" needs to be defined.
 ; - "rulesetdir" gives the directory where the ruleset is
-; - "serv" gives a server script to load, and which assumed to also set the rulesetdir
+; - "serv" gives a server script to load, and which is assumed to also set the rulesetdir
 rulesetdir = "multiplayer"
diff --git a/data/sandbox.modpack b/data/sandbox.modpack
index d0173b6d3a..58faf8b25b 100644
--- a/data/sandbox.modpack
+++ b/data/sandbox.modpack
@@ -13,5 +13,5 @@ ruleset = TRUE
 [ruleset]
 ; For modpacks with the ruleset component, either "rulesetdir" or "serv" needs to be defined.
 ; - "rulesetdir" gives the directory where the ruleset is
-; - "serv" gives a server script to load, and which assumed to also set the rulesetdir
+; - "serv" gives a server script to load, and which is assumed to also set the rulesetdir
 rulesetdir = "sandbox"
diff --git a/data/stub.modpack b/data/stub.modpack
index af69108a20..87e4c02634 100644
--- a/data/stub.modpack
+++ b/data/stub.modpack
@@ -13,5 +13,5 @@ ruleset = TRUE
 [ruleset]
 ; For modpacks with the ruleset component, either "rulesetdir" or "serv" needs to be defined.
 ; - "rulesetdir" gives the directory where the ruleset is
-; - "serv" gives a server script to load, and which assumed to also set the rulesetdir
+; - "serv" gives a server script to load, and which is assumed to also set the rulesetdir
 serv = "stub.serv"
diff --git a/data/webperimental.modpack b/data/webperimental.modpack
index 881dcb27d4..500d83f4bb 100644
--- a/data/webperimental.modpack
+++ b/data/webperimental.modpack
@@ -13,5 +13,5 @@ ruleset = TRUE
 [ruleset]
 ; For modpacks with the ruleset component, either "rulesetdir" or "serv" needs to be defined.
 ; - "rulesetdir" gives the directory where the ruleset is
-; - "serv" gives a server script to load, and which assumed to also set the rulesetdir
+; - "serv" gives a server script to load, and which is assumed to also set the rulesetdir
 rulesetdir = "webperimental"
-- 
2.43.0