From 107905f2b131787995b1ac77ee92624106dd2df6 Mon Sep 17 00:00:00 2001
From: Marko Lindqvist <cazfi74@gmail.com>
Date: Sun, 31 Mar 2024 22:55:39 +0300
Subject: [PATCH 56/56] Correct "abbrevation" to "abbreviation"

See RM #386

Signed-off-by: Marko Lindqvist <cazfi74@gmail.com>
---
 data/alien/cities.ruleset         | 2 +-
 data/civ1/cities.ruleset          | 2 +-
 data/civ2/cities.ruleset          | 2 +-
 data/civ2civ3/cities.ruleset      | 2 +-
 data/classic/cities.ruleset       | 2 +-
 data/goldkeep/cities.ruleset      | 2 +-
 data/granularity/cities.ruleset   | 2 +-
 data/multiplayer/cities.ruleset   | 2 +-
 data/ruledit/comments-3.3.txt     | 2 +-
 data/sandbox/cities.ruleset       | 2 +-
 data/stub/cities.ruleset          | 2 +-
 data/webperimental/cities.ruleset | 2 +-
 12 files changed, 12 insertions(+), 12 deletions(-)

diff --git a/data/alien/cities.ruleset b/data/alien/cities.ruleset
index 1922013c8b..7cd5ae7e4d 100644
--- a/data/alien/cities.ruleset
+++ b/data/alien/cities.ruleset
@@ -34,7 +34,7 @@ format_version = 40
 ;                 to rename an item after a ruleset has been released, you
 ;                 should set "rule_name" to the original value of "name".
 ; short_name    = one-character "short name" used (for instance) in cityrep;
-;                 should be first character/abbrevation of "name"
+;                 should be first character/abbreviation of "name"
 ; graphic       = tag specifying preferred graphic
 ;                 Different images based on citizen number are supported.
 ;                 If no such images indexed with citizen number are found,
diff --git a/data/civ1/cities.ruleset b/data/civ1/cities.ruleset
index f6cc37207b..13a5969532 100644
--- a/data/civ1/cities.ruleset
+++ b/data/civ1/cities.ruleset
@@ -30,7 +30,7 @@ format_version = 40
 ;                 to rename an item after a ruleset has been released, you
 ;                 should set "rule_name" to the original value of "name".
 ; short_name    = one-character "short name" used (for instance) in cityrep;
-;                 should be first character/abbrevation of "name"
+;                 should be first character/abbreviation of "name"
 ; graphic       = tag specifying preferred graphic
 ;                 Different images based on citizen number are supported.
 ;                 If no such images indexed with citizen number are found,
diff --git a/data/civ2/cities.ruleset b/data/civ2/cities.ruleset
index f6cc37207b..13a5969532 100644
--- a/data/civ2/cities.ruleset
+++ b/data/civ2/cities.ruleset
@@ -30,7 +30,7 @@ format_version = 40
 ;                 to rename an item after a ruleset has been released, you
 ;                 should set "rule_name" to the original value of "name".
 ; short_name    = one-character "short name" used (for instance) in cityrep;
-;                 should be first character/abbrevation of "name"
+;                 should be first character/abbreviation of "name"
 ; graphic       = tag specifying preferred graphic
 ;                 Different images based on citizen number are supported.
 ;                 If no such images indexed with citizen number are found,
diff --git a/data/civ2civ3/cities.ruleset b/data/civ2civ3/cities.ruleset
index a3f60dd96b..8d052cba40 100644
--- a/data/civ2civ3/cities.ruleset
+++ b/data/civ2civ3/cities.ruleset
@@ -30,7 +30,7 @@ format_version = 40
 ;                 to rename an item after a ruleset has been released, you
 ;                 should set "rule_name" to the original value of "name".
 ; short_name    = one-character "short name" used (for instance) in cityrep;
-;                 should be first character/abbrevation of "name"
+;                 should be first character/abbreviation of "name"
 ; graphic       = tag specifying preferred graphic
 ;                 Different images based on citizen number are supported.
 ;                 If no such images indexed with citizen number are found,
diff --git a/data/classic/cities.ruleset b/data/classic/cities.ruleset
index 03f017bc6a..fb606c242c 100644
--- a/data/classic/cities.ruleset
+++ b/data/classic/cities.ruleset
@@ -30,7 +30,7 @@ format_version = 40
 ;                 to rename an item after a ruleset has been released, you
 ;                 should set "rule_name" to the original value of "name".
 ; short_name    = one-character "short name" used (for instance) in cityrep;
-;                 should be first character/abbrevation of "name"
+;                 should be first character/abbreviation of "name"
 ; graphic       = tag specifying preferred graphic
 ;                 Different images based on citizen number are supported.
 ;                 If no such images indexed with citizen number are found,
diff --git a/data/goldkeep/cities.ruleset b/data/goldkeep/cities.ruleset
index 51ecd8b727..a178562650 100644
--- a/data/goldkeep/cities.ruleset
+++ b/data/goldkeep/cities.ruleset
@@ -32,7 +32,7 @@ format_version = 40
 ;                 to rename an item after a ruleset has been released, you
 ;                 should set "rule_name" to the original value of "name".
 ; short_name    = one-character "short name" used (for instance) in cityrep;
-;                 should be first character/abbrevation of "name"
+;                 should be first character/abbreviation of "name"
 ; graphic       = tag specifying preferred graphic
 ;                 Different images based on citizen number are supported.
 ;                 If no such images indexed with citizen number are found,
diff --git a/data/granularity/cities.ruleset b/data/granularity/cities.ruleset
index 5f32ea9dec..c0ab98bf5f 100644
--- a/data/granularity/cities.ruleset
+++ b/data/granularity/cities.ruleset
@@ -30,7 +30,7 @@ format_version = 40
 ;                 to rename an item after a ruleset has been released, you
 ;                 should set "rule_name" to the original value of "name".
 ; short_name    = one-character "short name" used (for instance) in cityrep;
-;                 should be first character/abbrevation of "name"
+;                 should be first character/abbreviation of "name"
 ; graphic       = tag specifying preferred graphic
 ;                 Different images based on citizen number are supported.
 ;                 If no such images indexed with citizen number are found,
diff --git a/data/multiplayer/cities.ruleset b/data/multiplayer/cities.ruleset
index bfff20c2c2..1bcb5762f7 100644
--- a/data/multiplayer/cities.ruleset
+++ b/data/multiplayer/cities.ruleset
@@ -29,7 +29,7 @@ format_version = 40
 ;                 to rename an item after a ruleset has been released, you
 ;                 should set "rule_name" to the original value of "name".
 ; short_name    = one-character "short name" used (for instance) in cityrep;
-;                 should be first character/abbrevation of "name"
+;                 should be first character/abbreviation of "name"
 ; graphic       = tag specifying preferred graphic
 ;                 Different images based on citizen number are supported.
 ;                 If no such images indexed with citizen number are found,
diff --git a/data/ruledit/comments-3.3.txt b/data/ruledit/comments-3.3.txt
index 8e847e0660..a63252331e 100644
--- a/data/ruledit/comments-3.3.txt
+++ b/data/ruledit/comments-3.3.txt
@@ -1186,7 +1186,7 @@ specialists = "\
 ;                 to rename an item after a ruleset has been released, you\n\
 ;                 should set \"rule_name\" to the original value of \"name\".\n\
 ; short_name    = one-character \"short name\" used (for instance) in cityrep;\n\
-;                 should be first character/abbrevation of \"name\"\n\
+;                 should be first character/abbreviation of \"name\"\n\
 ; graphic       = tag specifying preferred graphic\n\
 ;                 Different images based on citizen number are supported.\n\
 ;                 If no such images indexed with citizen number are found,\n\
diff --git a/data/sandbox/cities.ruleset b/data/sandbox/cities.ruleset
index 1965015533..59d014c3a0 100644
--- a/data/sandbox/cities.ruleset
+++ b/data/sandbox/cities.ruleset
@@ -30,7 +30,7 @@ format_version = 40
 ;                 to rename an item after a ruleset has been released, you
 ;                 should set "rule_name" to the original value of "name".
 ; short_name    = one-character "short name" used (for instance) in cityrep;
-;                 should be first character/abbrevation of "name"
+;                 should be first character/abbreviation of "name"
 ; graphic       = tag specifying preferred graphic
 ;                 Different images based on citizen number are supported.
 ;                 If no such images indexed with citizen number are found,
diff --git a/data/stub/cities.ruleset b/data/stub/cities.ruleset
index 6380f2ad1b..3dfb79a4e8 100644
--- a/data/stub/cities.ruleset
+++ b/data/stub/cities.ruleset
@@ -24,7 +24,7 @@ format_version = 40
 ;                 to rename an item after a ruleset has been released, you
 ;                 should set "rule_name" to the original value of "name".
 ; short_name    = one-character "short name" used (for instance) in cityrep;
-;                 should be first character/abbrevation of "name"
+;                 should be first character/abbreviation of "name"
 ; graphic       = tag specifying preferred graphic
 ;                 Different images based on citizen number are supported.
 ;                 If no such images indexed with citizen number are found,
diff --git a/data/webperimental/cities.ruleset b/data/webperimental/cities.ruleset
index d0b9dd4e65..3cfa2e2828 100644
--- a/data/webperimental/cities.ruleset
+++ b/data/webperimental/cities.ruleset
@@ -30,7 +30,7 @@ format_version = 40
 ;                 to rename an item after a ruleset has been released, you
 ;                 should set "rule_name" to the original value of "name".
 ; short_name    = one-character "short name" used (for instance) in cityrep;
-;                 should be first character/abbrevation of "name"
+;                 should be first character/abbreviation of "name"
 ; graphic       = tag specifying preferred graphic
 ;                 Different images based on citizen number are supported.
 ;                 If no such images indexed with citizen number are found,
-- 
2.43.0